Subject: Re: [PATCH v3] ipv6: Fix protocol resubmission

From: Josh Hunt <[email-masked]>
Date: Wed, 10 Jun 2015 16:57:25 -0500

On 06/10/2015 10:16 AM, YOSHIFUJI Hideaki wrote:
> Hi,
>
> Josh Hunt wrote:
>> On 06/09/2015 11:24 PM, Hajime Tazaki wrote:
>>>
>>> Hello Josh, Dave,
>>>
>>> my mobile ipv6 test on libos failed with this commit.
>>>
>>> This commit makes a destination option header handling (i.e.,
>>> ipprot->handler == ipv6_destopt_rcv) failed since
>>> ipv6_destopt_rcv() seems to return a positive value to
>>> indicate to goto resubmission label.
>>>
>>> I will look for more detail.
>>>
>>> -- Hajime
>>
>> Hajime
>>
>> Thanks for the report. I mentioned in an earlier post this might be a problem.
>>
>> Dave, what if we restore the old behavior, but add a new label to handle the case where the decapsulating protocol returns the nexthdr value? Allowing for migration over to this method over time. I've pasted in a patch doing so below.
>
> I think it is insufficient because IPv6 stack already uses
> positive value, 0 and negative values.
>
>>
>> The other solution I guess is to change how the udp handler works, but I was hoping to keep it behaving the same as v4.
>
> xfrm returns different value for IPv4 and IPv6, for example,
> so udp can do in the same way.  And we can use the fact that
> the size of next header field is 8-bit.
>

Dave

Can you please revert this change?

commit 0243508edd317ff1fa63b495643a7c192fbfcd92
Author: Josh Hunt <[email-masked]>
Date:   Mon Jun 8 12:00:59 2015 -0400

     ipv6: Fix protocol resubmission

Let me know if you need a patch to do this and I will submit something.

I will fix the original issue in the UDP code in another patch.

Josh